searchData={"items":[{"type":"module","title":"GitOps.Changelog","doc":"Functions for writing commits to the changelog, and initializing it.","ref":"GitOps.Changelog.html"},{"type":"function","title":"GitOps.Changelog.initialize/2","doc":"","ref":"GitOps.Changelog.html#initialize/2"},{"type":"function","title":"GitOps.Changelog.write/5","doc":"","ref":"GitOps.Changelog.html#write/5"},{"type":"module","title":"GitOps.Commit","doc":"Manages the structure, parsing, and formatting of commits.\n\nUsing `parse/1` you can parse a commit struct out of a commit message\n\nUsing `format/1` you can format a commit struct in the way that the\nchangelog expects.","ref":"GitOps.Commit.html"},{"type":"function","title":"GitOps.Commit.breaking?/1","doc":"","ref":"GitOps.Commit.html#breaking?/1"},{"type":"function","title":"GitOps.Commit.feature?/1","doc":"","ref":"GitOps.Commit.html#feature?/1"},{"type":"function","title":"GitOps.Commit.fix?/1","doc":"","ref":"GitOps.Commit.html#fix?/1"},{"type":"function","title":"GitOps.Commit.format/1","doc":"","ref":"GitOps.Commit.html#format/1"},{"type":"function","title":"GitOps.Commit.parse/1","doc":"","ref":"GitOps.Commit.html#parse/1"},{"type":"type","title":"GitOps.Commit.t/0","doc":"","ref":"GitOps.Commit.html#t:t/0"},{"type":"module","title":"GitOps.Config","doc":"Helpers around fetching configurations, including setting defaults.","ref":"GitOps.Config.html"},{"type":"function","title":"GitOps.Config.allow_untagged?/0","doc":"","ref":"GitOps.Config.html#allow_untagged?/0"},{"type":"function","title":"GitOps.Config.allowed_tags/0","doc":"","ref":"GitOps.Config.html#allowed_tags/0"},{"type":"function","title":"GitOps.Config.changelog_file/0","doc":"","ref":"GitOps.Config.html#changelog_file/0"},{"type":"function","title":"GitOps.Config.manage_mix_version?/0","doc":"","ref":"GitOps.Config.html#manage_mix_version?/0"},{"type":"function","title":"GitOps.Config.manage_readme_version/0","doc":"","ref":"GitOps.Config.html#manage_readme_version/0"},{"type":"function","title":"GitOps.Config.mix_project/0","doc":"","ref":"GitOps.Config.html#mix_project/0"},{"type":"function","title":"GitOps.Config.mix_project_check/1","doc":"","ref":"GitOps.Config.html#mix_project_check/1"},{"type":"function","title":"GitOps.Config.prefix/0","doc":"","ref":"GitOps.Config.html#prefix/0"},{"type":"function","title":"GitOps.Config.repository_path/0","doc":"","ref":"GitOps.Config.html#repository_path/0"},{"type":"function","title":"GitOps.Config.repository_url/0","doc":"","ref":"GitOps.Config.html#repository_url/0"},{"type":"function","title":"GitOps.Config.types/0","doc":"","ref":"GitOps.Config.html#types/0"},{"type":"module","title":"GitOps.Git","doc":"Helper functions for working with `Git` and fetching the tags/commits we care about.","ref":"GitOps.Git.html"},{"type":"function","title":"GitOps.Git.add!/2","doc":"","ref":"GitOps.Git.html#add!/2"},{"type":"function","title":"GitOps.Git.commit!/2","doc":"","ref":"GitOps.Git.html#commit!/2"},{"type":"function","title":"GitOps.Git.commit_messages_since_tag/2","doc":"","ref":"GitOps.Git.html#commit_messages_since_tag/2"},{"type":"function","title":"GitOps.Git.get_initial_commits!/1","doc":"","ref":"GitOps.Git.html#get_initial_commits!/1"},{"type":"function","title":"GitOps.Git.hooks_path/1","doc":"","ref":"GitOps.Git.html#hooks_path/1"},{"type":"function","title":"GitOps.Git.init!/1","doc":"","ref":"GitOps.Git.html#init!/1"},{"type":"function","title":"GitOps.Git.tag!/2","doc":"","ref":"GitOps.Git.html#tag!/2"},{"type":"function","title":"GitOps.Git.tags/1","doc":"","ref":"GitOps.Git.html#tags/1"},{"type":"module","title":"GitOps.Version","doc":"Functionality around parsing and comparing versions contained in git tags","ref":"GitOps.Version.html"},{"type":"function","title":"GitOps.Version.determine_new_version/5","doc":"","ref":"GitOps.Version.html#determine_new_version/5"},{"type":"function","title":"GitOps.Version.last_valid_non_rc_version/2","doc":"","ref":"GitOps.Version.html#last_valid_non_rc_version/2"},{"type":"function","title":"GitOps.Version.last_valid_version/2","doc":"","ref":"GitOps.Version.html#last_valid_version/2"},{"type":"function","title":"GitOps.Version.last_version_greater_than/3","doc":"","ref":"GitOps.Version.html#last_version_greater_than/3"},{"type":"module","title":"GitOps.VersionReplace","doc":"Functions that handle the logic behind replacing the version in related files.","ref":"GitOps.VersionReplace.html"},{"type":"function","title":"GitOps.VersionReplace.update_mix_project/4","doc":"","ref":"GitOps.VersionReplace.html#update_mix_project/4"},{"type":"function","title":"GitOps.VersionReplace.update_readme/4","doc":"","ref":"GitOps.VersionReplace.html#update_readme/4"},{"type":"task","title":"mix git_ops.check_message","doc":"Receives a file path and validates if it's content follows the Conventional Commits specification.\n\n    mix git_ops.check_message  \n\nLogs an error if the commit message is not parse-able.\n\nSee https://www.conventionalcommits.org/en/v1.0.0/ for more details on Conventional Commits.","ref":"Mix.Tasks.GitOps.CheckMessage.html"},{"type":"task","title":"mix git_ops.message_hook","doc":"Installs a Git commit-msg hook to automatically check if the commit message follows\nthe Conventional Commits spec:\n\n    mix git_ops.message_hook\n\nThe actual check is done by using the git_ops.check_message mix task:\n\n    mix git_ops.check_message /path/to/commit/message/file\n\nIt does nothing if a Git commit-msg hook already exists that contains the above\nmessage validation task (unless --force was used).\n\nLogs an error if a Git commit-msg hook exists but it does not call the message\nvalidation task.","ref":"Mix.Tasks.GitOps.MessageHook.html"},{"type":"task","title":"Switches: - mix git_ops.message_hook","doc":"* `--force|-f` - Overwrites the Git commit-msg hook if one exists but it does not\n  call the message validation task.\n\n* `--uninstall` - Uninstalls the git commit-msg hook if it exists.\n\n* `--verbose|-v` - Be more verbose. Pass this option twice to be even more verbose.","ref":"Mix.Tasks.GitOps.MessageHook.html#module-switches"},{"type":"task","title":"mix git_ops.project_info","doc":"A handy helper which prints out the app name and version number.\n\nMay be useful in your CI system.\n\n    mix git_ops.project_info","ref":"Mix.Tasks.GitOps.ProjectInfo.html"},{"type":"task","title":"Switches: - mix git_ops.project_info","doc":"* `--format|-f` selects the output format. Currently suported output formats\n  are `json`, `toml`, `github-actions`, `shell` and `dotenv`.","ref":"Mix.Tasks.GitOps.ProjectInfo.html#module-switches"},{"type":"task","title":"mix git_ops.release","doc":"Updates project changelog, and any other configured release capabilities.\n\n    mix git_ops.release\n\nLogs an error for any commits that were not parseable.\n\nIn the case that the prior version was a pre-release and this one is not,\nthe version is only updated via removing the pre-release identifier.\n\nFor more information on semantic versioning, including pre release and build identifiers,\nsee the specification here: https://semver.org/","ref":"Mix.Tasks.GitOps.Release.html"},{"type":"task","title":"Switches: - mix git_ops.release","doc":"* `--initial` - Creates the first changelog, and sets the version to whatever the\n  configured mix project's version is.\n\n* `--pre-release` - Sets this release to be a pre release, using the configured\n  string as the pre release identifier. This is a manual process, and results in\n  an otherwise unchanged version. (Does not change the minor version).\n  The version number will only change if a *higher* version number bump is required\n  than what was originally changed in the creation of the RC. For instance, if patch\n  was changed when creating the pre-release, and no fixes or features were added when\n  requesting a new pre-release, then the version will not change. However, if the last\n  pre-release had only a patch version bump, but a major change has since been added,\n  the version will be changed accordingly.\n\n* `--rc` - Overrides the presence of `--pre-release`, and manages an incrementing\n  identifier as the prerelease. This will look like `1.0.0-rc0` `1.0.0-rc1` and so\n  forth. See the `--pre-release` flag for information on when the version will change\n  for a pre-release. In the case that the version must change, the counter for\n  the release candidate counter will be reset as well.\n\n* `--build` - Sets the release build metadata. Build information has no semantic\n  meaning to the version itself, and so is simply attached to the end and is to\n  be used to describe the build conditions for that release. You might build the\n  same version many times, and this can be used to denote that in whatever way\n  you choose.\n\n* `--force-patch` - In cases where this task is run, but the version should not\n  change, this option will force the patch number to be incremented.\n\n* `--no-major` - Forces major version changes to instead only result in minor version\n  changes. This would be a common option for libraries that are still in 0.x.x phases\n  where 1.0.0 should only happen at some specified milestones. After that, it is important\n  to *not* resist a 2.x.x change just because it doesn't seem like it deserves it.\n  Semantic versioning uses this major version change to communicate, and it should not be\n  reserved.\n\n* `--dry-run` - Allow users to run release process and view changes without committing and tagging\n\n* `--yes` - Don't prompt for confirmation, just perform release.  Useful for your CI run.\n\n* `--override` - Provide an explicit version override","ref":"Mix.Tasks.GitOps.Release.html#module-switches"},{"type":"extras","title":"GitOps","doc":"# GitOps\n\n[![Hex pm](http://img.shields.io/hexpm/v/git_ops.svg?style=flat)](https://hex.pm/packages/git_ops)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/git_ops/)\n[![Total Download](https://img.shields.io/hexpm/dt/git_ops.svg)](https://hex.pm/packages/git_ops)\n[![License](https://img.shields.io/hexpm/l/git_ops.svg)](https://github.com/zachdaniel/git_opts/blob/master/LICENSE)\n[![Build Status](https://travis-ci.com/zachdaniel/git_ops.svg?branch=master)](https://travis-ci.com/zachdaniel/git_ops)\n[![Inline docs](http://inch-ci.org/github/zachdaniel/git_ops.svg?branch=master)](http://inch-ci.org/github/zachdaniel/git_ops)\n[![Coverage Status](https://coveralls.io/repos/github/zachdaniel/git_ops/badge.svg?branch=master)](https://coveralls.io/github/zachdaniel/git_ops?branch=master)\n\nA small tool to help generate changelogs from conventional commit messages.\nFor more information, see [conventional\ncommits](https://conventionalcommits.org).\nFor an example, see this project's [CHANGELOG.md](https://github.com/zachdaniel/git_ops/blob/master/CHANGELOG.md).\n\nRoadmap (in no particular order):\n\n- More tests\n- Automatically parse issue numbers and github mentions into the correct format, linking the issue\n- A task to build a compliant commit\n- Validation of commits\n- Automatically link to the PR that merged a given commit in the changelog\n- A hundred other things I forgot to write down while writing the initial version\n\nImportant addendums:\n\nA new version of the spec in beta adds a rather useful\nconvention. Add ! after the type/scope to simply signal it as a breaking\nchange, instead of adding `BREAKING CHANGE: description` in your commit message.\nFor example: `fix(Spline Reticulator)!: `\n\nThe spec doesn't specify behavior around multiple scopes. This library parses\nscopes _as a comma separated list_. This allows for easily readable multiple\nword lists `feat(Something Special, Something Else Special): message`. Keep in\nmind that you are very limited on space in these messages, and if you find\nyourself using multiple scopes your commit is probably too big.","ref":"readme.html"},{"type":"extras","title":"Installation - GitOps","doc":"```elixir\ndef deps do\n  [\n    {:git_ops, \"~> 2.6.1\", only: [:dev]}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - GitOps","doc":"```elixir\nconfig :git_ops,\n  mix_project: Mix.Project.get!(),\n  changelog_file: \"CHANGELOG.md\",\n  repository_url: \"https://github.com/my_user/my_repo\",\n  types: [\n    # Makes an allowed commit type called `tidbit` that is not\n    # shown in the changelog\n    tidbit: [\n      hidden?: true\n    ],\n    # Makes an allowed commit type called `important` that gets\n    # a section in the changelog with the header \"Important Changes\"\n    important: [\n      header: \"Important Changes\"\n    ]\n  ],\n  tags: [\n    # Only add commits to the changelog that has the \"backend\" tag\n    allowed: [\"backend\"],\n    # Filter out or not commits that don't contain tags\n    allow_untagged?: true\n  ],\n  # Instructs the tool to manage your mix version in your `mix.exs` file\n  # See below for more information\n  manage_mix_version?: true,\n  # Instructs the tool to manage the version in your README.md\n  # Pass in `true` to use `\"README.md\"` or a string to customize\n  manage_readme_version: \"README.md\",\n  version_tag_prefix: \"v\"\n```\n\nGetting started:\n\n```bash\nmix git_ops.release --initial\n```\n\nCommit the result of that, using a message like `chore: Initial Release`\n\nThen when you want to release again, use:\n\n```bash\nmix git_ops.release\n```\n\nFor the full documentation of that task, see the task documentation in hex.","ref":"readme.html#configuration"},{"type":"extras","title":"Managing your mix version - GitOps","doc":"To have mix manage your mix version, add `manage_mix_version?: true` to your configuration.\n\nThen, use a module attribute called `@version` to manage your application's\nversion. Look at [this project's mix.exs](mix.exs) for an example.","ref":"readme.html#managing-your-mix-version"},{"type":"extras","title":"Managing your readme version - GitOps","doc":"Most project readmes have a line like this that would ideally remain up to date:\n\n```elixir\n    {:git_ops, \"~> 2.6.1\", only: [:dev]}\n```\n\nYou can keep that number up to date via `manage_readme_version`, which accepts\n`true` for `README.md` or a string pointing to some other path relative to your\nproject root.","ref":"readme.html#managing-your-readme-version"},{"type":"extras","title":"Using this with open source projects - GitOps","doc":"If you'd like your contributors to use the conventional commit format, you can\nuse a PULL_REQUEST_TEMPLATE.md like the one in our repo. However,\nit is also possible to manage it as the maintainers of a project by altering\neither the merge commit or alter the commit when merging/squashing (recommended)","ref":"readme.html#using-this-with-open-source-projects"},{"type":"extras","title":"Similar projects - GitOps","doc":"- https://github.com/glasnoster/eliver\n- https://github.com/oo6/mix-bump\n- https://github.com/mpanarin/versioce","ref":"readme.html#similar-projects"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}